LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_counter IS
END tb_counter;
 
ARCHITECTURE behavior OF tb_counter IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT counter
    PORT(
         ClkSlow : IN  std_logic;
         Reset : IN  std_logic;
         Enable : IN  std_logic;
         CountDown : IN  std_logic;
         CounterOut : OUT  std_logic_vector(3 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal ClkSlow : std_logic := '0';
   signal Reset : std_logic := '0';
   signal Enable : std_logic := '0';
   signal CountDown : std_logic := '0';

 	--Outputs
   signal CounterOut : std_logic_vector(3 downto 0);

   -- Clock period definitions
   constant ClkSlow_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: counter PORT MAP (
          ClkSlow => ClkSlow,
          Reset => Reset,
          Enable => Enable,
          CountDown => CountDown,
          CounterOut => CounterOut
        );

   -- Clock process definitions
   ClkSlow_process :process
   begin
		ClkSlow <= '0';
		wait for ClkSlow_period/2;
		ClkSlow <= '1';
		wait for ClkSlow_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for ClkSlow_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
