LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_edge_det IS
END tb_edge_det;
 
ARCHITECTURE behavior OF tb_edge_det IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT edge_det
    PORT(
         ClkSlow : IN  std_logic;
         SignalIn : IN  std_logic;
         PosEdge : OUT  std_logic;
         NegEdge : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal ClkSlow : std_logic := '0';
   signal SignalIn : std_logic := '0';

 	--Outputs
   signal PosEdge : std_logic;
   signal NegEdge : std_logic;

   -- Clock period definitions
   constant ClkSlow_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: edge_det PORT MAP (
          ClkSlow => ClkSlow,
          SignalIn => SignalIn,
          PosEdge => PosEdge,
          NegEdge => NegEdge
        );

   -- Clock process definitions
   ClkSlow_process :process
   begin
		ClkSlow <= '0';
		wait for ClkSlow_period/2;
		ClkSlow <= '1';
		wait for ClkSlow_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for ClkSlow_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
