LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_event_counter IS
END tb_event_counter;
 
ARCHITECTURE behavior OF tb_event_counter IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT event_counter
    PORT(
         EventCtrOut : OUT  std_logic_vector(3 downto 0);
         ClkSlow : IN  std_logic;
         Reset : IN  std_logic;
         SignalA : IN  std_logic;
         SignalB : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal ClkSlow : std_logic := '0';
   signal Reset : std_logic := '0';
   signal SignalA : std_logic := '0';
   signal SignalB : std_logic := '0';

 	--Outputs
   signal EventCtrOut : std_logic_vector(3 downto 0);

   -- Clock period definitions
   constant ClkSlow_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: event_counter PORT MAP (
          EventCtrOut => EventCtrOut,
          ClkSlow => ClkSlow,
          Reset => Reset,
          SignalA => SignalA,
          SignalB => SignalB
        );

   -- Clock process definitions
   ClkSlow_process :process
   begin
		ClkSlow <= '0';
		wait for ClkSlow_period/2;
		ClkSlow <= '1';
		wait for ClkSlow_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for ClkSlow_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
