-- TestBench Template 

  LIBRARY ieee;
  USE ieee.std_logic_1164.ALL;
  USE ieee.numeric_std.ALL;

  ENTITY tb_fpga_top IS
  END tb_fpga_top;

  ARCHITECTURE behavior OF tb_fpga_top IS 

  -- Component Declaration
		  COMPONENT fpga_top is
   			  PORT(
					--4x LEDs
					LED 	: out std_logic_vector(3 downto 0);

					--40 MHz external clock pulse
					USER_CLOCK : in std_logic;

					--external asynchronous reset (high-active)
					USER_RESET : in std_logic;

					--4x DIP Switches
					DIP		   : in std_logic_vector(3 downto 0)
                  );
          END COMPONENT;

		  SIGNAL LED : std_logic_vector(3 downto 0);
		  SIGNAL USER_CLOCK : std_logic := '0';
		  SIGNAL USER_RESET : std_logic;
		  SIGNAL DIP	: std_logic_vector(3 downto 0);

		  constant USER_CLOCK_period : time := 10 ns;
          

  BEGIN

  -- Clock process definitions
	  USER_CLOCKprocess: process
	  begin
		  USER_CLOCK <= '0';
		  wait for USER_CLOCK_period/2;
		  USER_CLOCK <= '1';
		  wait for USER_CLOCK_period/2;
	  end process;



  -- Component Instantiation
          uut: fpga_top PORT MAP(
                  LED => LED,
                  USER_CLOCK => USER_CLOCK,
				  DIP => DIP,
				  USER_RESET => USER_RESET 
          );


	 --stimulus process
     stim_proc: process
     BEGIN

        wait for 100 ns; -- wait until global set/reset completes

        -- Add user defined stimulus here

        wait; -- will wait forever
     END PROCESS tb;
  --  End Test Bench 

  END;
