LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_shift_reg IS
END tb_shift_reg;
 
ARCHITECTURE behavior OF tb_shift_reg IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT shift_reg
    PORT(
         ClkSlow : IN  std_logic;
         Reset : IN  std_logic;
         enable : IN  std_logic;
         ShiftRight : IN  std_logic;
         ShiftRegOut : OUT  std_logic_vector(3 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal ClkSlow : std_logic := '0';
   signal Reset : std_logic := '0';
   signal enable : std_logic := '0';
   signal ShiftRight : std_logic := '0';

 	--Outputs
   signal ShiftRegOut : std_logic_vector(3 downto 0);

   -- Clock period definitions
   constant ClkSlow_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: shift_reg PORT MAP (
          ClkSlow => ClkSlow,
          Reset => Reset,
          enable => enable,
          ShiftRight => ShiftRight,
          ShiftRegOut => ShiftRegOut
        );

   -- Clock process definitions
   ClkSlow_process :process
   begin
		ClkSlow <= '0';
		wait for ClkSlow_period/2;
		ClkSlow <= '1';
		wait for ClkSlow_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for ClkSlow_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
