LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity clk_div is
GENERIC (PERIOD : Integer := 10); --PARAMETER BY HOW MUCH TO DIVIDE THE CLOCK (COUNTER PERIOD IN CLOCK TICKS)
PORT(
        ClkIn 		: IN  STD_LOGIC;
        ClkSlow     : OUT STD_LOGIC);
end clk_div;





architecture a of clk_div is
	SIGNAL q   : STD_LOGIC := '0';	--Initial value only for simulation
begin


process(ClkIn) -- frequency divider
	variable cnt : Integer range 0 to PERIOD-1; --Counter variable
begin
	if rising_edge(ClkIn) then	--Count with the rising edge of the clock
			if cnt=0 then				--If the counter has reached 0 reset to PERIOD-1 and create the rising edge of the slow clock
				cnt := PERIOD-1; 
				q <= '1';
			 else 
				 cnt := cnt - 1;
			end if;
			if cnt = (PERIOD/2) then
				q <= '0';
			end if;
			
	end if;
end process;

ClkSlow <= q;

end;
