LIBRARY IEEE;
use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_ARITH.ALL;	--required for the arithmetic with std_logic
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- up/down counter
entity counter is
port(
     ClkSlow	: in  std_logic;
     Reset		: in  std_logic; -- here asynchronous reset
     Enable		: in  std_logic; -- enable
     CountDown	: in  std_logic; -- down when 1, else up
     CounterOut	: out std_logic_vector(3 downto 0)
);
end counter;

architecture a of counter is

signal cnt : std_logic_vector(3 downto 0);

begin

    process(ClkSlow, Reset)
    begin
        if Reset = '1' then
            cnt <= (others => '0');
        elsif rising_edge(ClkSlow) then
            if Enable = '1' then

				cnt <= not cnt;

            end if;
        end if;
    end process;

    CounterOut <= cnt;
end;
