Library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;

Library UNISIM;
use UNISIM.vcomponents.all;

entity dp_mem is
	port(
			DpMemOut : out std_logic_vector(2 downto 0);
			FullMem : out std_logic;
			ClkSlow : in std_logic;
			Reset 	: in std_logic;
			DpMemIn : in std_logic_vector(2 downto 0);
			Command : in std_logic
	    );
end dp_mem;




architecture implementation of dp_mem is



begin


	DpMemOut <= "000";
	FullMem <= '0';




   -- RAMB16BWER: 16k-bit Data and 2k-bit Parity Configurable Synchronous Dual Port Block RAM with Optional Output Registers
   --             Spartan-6
   -- Usage:
   --    * port A --> write data to memory
   --    * port B --> retrieve data from memory


	


--   RAMB16BWER_inst : RAMB16BWER
--   generic map (
--      DATA_WIDTH_A        => 36,             -- Data width for port A (0, 1, 2, 4, 9, 18 or 36)
--      DATA_WIDTH_B        => 36,             -- Data width for port B (0, 1, 2, 4, 9, 18 or 36)
--      DOA_REG             => 0,              -- Bypass (0) or use (1) the output registers of the RAM
--      DOB_REG             => 0,              -- Bypass (0) or use (1) the output registers of the RAM
--      EN_RSTRAM_A         => TRUE,           -- Enable (TRUE) or disable (FALSE) A port RST
--      EN_RSTRAM_B         => TRUE,           -- Enable (TRUE) or disable (FALSE) B port RST
--      INIT_A              => (others => '0'),-- Initial values on output port A
--      INIT_B              => (others => '0'),-- Initial values on output port B
--      INIT_FILE           => "NONE",         -- Name of file used to specify initial RAM contents
--      RSTTYPE             => "SYNC",         -- Type of reset synchronous (SYNC) or asynchronous (ASYNC)
--      RST_PRIORITY_A      => "CE",           -- SR = Reset; CE = REGCE (if DO_REG = 1) or EN (otherwise)
--      RST_PRIORITY_B      => "CE",           -- SR = Reset; CE = REGCE (if DO_REG = 1) or EN (otherwise)
--      SIM_DEVICE          => "SPARTAN3ADSP",
--      SRVAL_A             => (others => '0'),-- Output value of port A upon a reset signal
--      SRVAL_B             => (others => '0'),-- Output value of port B upon a reset signal
--      WRITE_MODE_A        => "WRITE_FIRST",  -- Output behaviour of port A: "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE"
--      WRITE_MODE_B        => "WRITE_FIRST",  -- Output behaviour of port B: "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE"
--      SIM_COLLISION_CHECK => "ALL"           -- Collision check enable: "ALL", "WARNING_ONLY", "GENERATE_X_ONLY" or "NONE"
--   )
--   port map (
--      CLKA                => CLKA,           -- Clock input - port A (1-bit)
--      CLKB                => CLKB,           -- Clock input - port B (1-bit)
--      ENA                 => ENA,            -- Enable - port A (1-bit)
--      ENB                 => ENB,            -- Enable - port B (1-bit)
--      WEA                 => WEA,            -- Byte-wide write enable - port A (4-bit)
--      WEB                 => WEB,            -- Byte-wide write enable - port B (4-bit)
--      DOA                 => DOA,            -- Output data - port A (32-bit)
--      DOB                 => DOB,            -- Output data - port B (32-bit)
--      DOPA                => DOPA,           -- Output parity data - port A (4-bit)
--      DOPB                => DOPB,           -- Output parity data - port B (4-bit)
--      ADDRA               => ADDRA,          -- Port A Address/Control Signals (14-bit)
--      ADDRB               => ADDRB,          -- Port B Address/Control Signals (14-bit)
--      DIA                 => DIA,            -- Input data on port A (32-bit)
--      DIB                 => DIB,            -- Input data on port B (32-bit)
--      DIPA                => DIPA,           -- Input parity data on port A (4-bit)
--      DIPB                => DIPB,           -- Input parity data on port A (4-bit)
--      REGCEA              => REGCEA,         -- Output register clock enable - port A (1-bit)
--      REGCEB              => REGCEB,         -- Output register clock enable - port B (1-bit)
--      RSTA                => RSTA,           -- Set/reset input - port A (1-bit)
--      RSTB                => RSTB            -- Set/reset input - port B (1-bit)
--   );







end;

