LIBRARY IEEE;
use IEEE.std_logic_1164.all;

-- shift register with direction control
entity shift_reg is
port(
     ClkSlow		: in  std_logic;
     Reset  		: in  std_logic; -- asynchronous reset
     enable  		: in  std_logic; -- enable
     ShiftRight 	: in  std_logic; -- direction
     ShiftRegOut	: out std_logic_vector(3 downto 0)
 );
end shift_reg;

architecture a of shift_reg is

signal shiftreg : std_logic_vector(3 downto 0);

begin
    process(ClkSlow, Reset)
    begin
        if Reset = '1' then
            shiftreg <= "0001"; -- initial value of the shift register
        elsif rising_edge(ClkSlow) then
            if enable = '1' then
				shiftreg <= not shiftreg;
            end if;
        end if;
    end process;


    ShiftRegOut <= shiftreg;
end;
